;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_INITIALISIERUNG:
	; DCF-EINGANG						
	cbi (DCF_DDR) ,(DCF_PIN_NR) ; auf EINGANG
	cbi (DCF_PORT),(DCF_PIN_NR) ; PULL UP aus, wichtig, denn manche DCF-Module sehr hochohmig !
	; DCF-INVERTIEREN					
	cbi (DCF_INV_DDR) ,(DCF_INV_PIN_NR) ; auf EINGANG
	sbi (DCF_INV_PORT),(DCF_INV_PIN_NR) ; PULL UP ein
	; DCF-PULL-UP						
	cbi (DCF_PUL_DDR) ,(DCF_PUL_PIN_NR) ; auf EINGANG
	sbi (DCF_PUL_PORT),(DCF_PUL_PIN_NR) ; PULL UP ein
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; PIN abfragen																
DCF_EINGANGSPEGEL_INVERTIEREN_ABFRAGEN:
	; PIN abfragen		
	sbic DCF_INV_PIN,DCF_INV_PIN_NR	; springe, wenn...
	rjmp DCF_EINGANGSPEGEL_INVERTIEREN_ABFRAGEN_0
	rjmp DCF_EINGANGSPEGEL_INVERTIEREN_ABFRAGEN_1
DCF_EINGANGSPEGEL_INVERTIEREN_ABFRAGEN_0:
	STS(adr_DCF_INVERTIERMODUS),NULL	; NULL
	ret
DCF_EINGANGSPEGEL_INVERTIEREN_ABFRAGEN_1:
	STS(adr_DCF_INVERTIERMODUS),EINS	; EINS
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_EINGANGS_PULL_UP_AKTIVIEREN:
	; PIN abfragen		
	sbic DCF_PUL_PIN,DCF_PUL_PIN_NR	; springe, wenn...
	rjmp DCF_EINGANGS_PULL_UP_AKTIVIEREN_0
	rjmp DCF_EINGANGS_PULL_UP_AKTIVIEREN_1
DCF_EINGANGS_PULL_UP_AKTIVIEREN_0:
	STS(adr_DCF_PULL_UP),NULL			; NULL
	ret
DCF_EINGANGS_PULL_UP_AKTIVIEREN_1:
	STS(adr_DCF_PULL_UP),EINS			; EINS
	sbi (DCF_PORT),(DCF_PIN_NR) 		; PULL UP ein
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; DCF77-TRGER=ON=MODULAUSGANG=5V (NORMALMODUS)								
; DCF77-TRGER=ON=MODULAUSGANG=0V (INVERTIERMODUS)							
; Abtastung erfolgt 100 mal pro Sekunde										
; LED GELB muss leuchten, wenn DCF77 Trger ausgetastet ist					
; OUT: temp1																
DCF_PIN_ABFRAGEN_TEMP1:
	; INVERTIERMODUS ?	
	LDS temp,(adr_DCF_INVERTIERMODUS)
	tst temp
	brne DCF_PIN_ABFRAGEN_TEMP1_NORMAL
	rjmp DCF_PIN_ABFRAGEN_TEMP1_INVERTIERT

DCF_PIN_ABFRAGEN_TEMP1_INVERTIERT:
	; PIN abfragen		
	sbic DCF_PIN,DCF_PIN_NR	; springe, wenn...
	rjmp DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_OFF
	rjmp DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_ON
DCF_PIN_ABFRAGEN_TEMP1_NORMAL:
	; PIN abfragen		
	sbic DCF_PIN,DCF_PIN_NR	; springe, wenn...
	rjmp DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_ON
	rjmp DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_OFF
DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_OFF:
	clr temp1					; temp1=0=LED off	
	rjmp DCF_PIN_ABFRAGEN_TEMP1_FERTIG
DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_ON:
	ldi temp1,1					; temp1=1=LED on	
DCF_PIN_ABFRAGEN_TEMP1_FERTIG:
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_PIN_PHASE_TEMP1:
	; PHASE (ZEIGER + 1)		
	LDS temp,(adr_DCF_SAMPLES_ZEIGER)
	inc temp
	STS(adr_DCF_SAMPLES_ZEIGER),temp
	cpi temp,100
	brlo DCF_PIN_PHASE_TEMP1_w
	STS(adr_DCF_SAMPLES_ZEIGER),NULL
DCF_PIN_PHASE_TEMP1_w:
;---------------------------------------------------------------------------
	; PEGEL=1 ?		
	tst temp1
	breq DCF_PIN_PHASE_TEMP1_FERTIG
	; OLD <> momentaner Impuls ?
	LDS temp,(adr_DCF_IMPULS_OLD)
	cp temp,temp1
	breq DCF_PIN_PHASE_TEMP1_FERTIG
	LDS temp,(adr_DCF_SAMPLES_ZEIGER)	
	; PHASE speichern			
	STS(adr_DCF_IMPULS_PHASE),temp
;---------------------------------------------------------------------------
	; Phase schieben								
;---------------------------------------------------------------------------
	; 1 (nicht schieben)							
	LDS temp,(adr_DCF_IMPULS_PHASE)
	cpi temp, 1
	breq DCF_PIN_PHASE_TEMP1_OK
	; hat TIMER schon freigegeben ?					
	LDS temp,(adr_DCF_PHASE_TIMER)
	tst temp
	brne DCF_PIN_PHASE_TEMP1_FERTIG
	; 0 (vorsichtig schieben)						
	LDS temp,(adr_DCF_IMPULS_PHASE)
	cpi temp, 0	
	breq DCF_PIN_PHASE_TEMP1_PLUS
	; 2	 (vorsichtig schieben)						
	cpi temp,2
	breq DCF_PIN_PHASE_TEMP1_MINUS
	; DCF gltig, wenn ja alle Strungen ignorieren	
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	brne DCF_PIN_PHASE_TEMP1_OK
	; PHASE RESET (auf "1")							
	rjmp DCF_PIN_PHASE_TEMP1_RESET
;---------------------------------------------------------------------------
DCF_PIN_PHASE_TEMP1_RESET:
	STS(adr_DCF_SAMPLES_ZEIGER),EINS
	rjmp DCF_PIN_PHASE_TEMP1_OK
;---------------------------------------------------------------------------
DCF_PIN_PHASE_TEMP1_PLUS:
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)			; GELB 		
	LDS temp,(adr_DCF_SAMPLES_ZEIGER)
	inc temp
	STS(adr_DCF_SAMPLES_ZEIGER),temp
	cpi temp,100
	brlo DCF_PIN_PHASE_TEMP1_OK
	STS(adr_DCF_SAMPLES_ZEIGER),NULL
	rjmp DCF_PIN_PHASE_TEMP1_OK
;---------------------------------------------------------------------------
DCF_PIN_PHASE_TEMP1_MINUS:
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)			; GRN 		
	LDS temp,(adr_DCF_SAMPLES_ZEIGER)
	dec temp
	STS(adr_DCF_SAMPLES_ZEIGER),temp
	rjmp DCF_PIN_PHASE_TEMP1_OK
;---------------------------------------------------------------------------
DCF_PIN_PHASE_TEMP1_OK:
	; TIMERWERT						
	ldi temp,(DCF_PHASE_TIMERWERT)
	STS(adr_DCF_PHASE_TIMER),temp
;---------------------------------------------------------------------------
DCF_PIN_PHASE_TEMP1_FERTIG:
	; OLD speichern				
	STS(adr_DCF_IMPULS_OLD),temp1

;######################################################################## 	
;########################################################################	
;######################################################################## 	
; LED-GELB-AUSWERTUNG														
; INP/OUT: temp1															
DCF_LED_TEMP1:
	tst temp1	
	breq DCF_LED_TEMP1_OFF
	rjmp DCF_LED_TEMP1_ON
DCF_LED_TEMP1_ON:
	; LED blinkt, wenn DCF Signal nicht gltig	
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	brne DCF_LED_TEMP1_OFF
	cbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	 ; GELB-AN	
	rjmp DCF_LED_TEMP_FERTIG
DCF_LED_TEMP1_OFF:
	sbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	 ; GELB-AUS	
DCF_LED_TEMP_FERTIG:
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; LOW=100ms(10) HIGH=200ms(20)												
;  10ms=00=nix																
;  20ms=01=Initialisierung													
;  30ms=02=SAMPLES-A														
;  40ms=03=SAMPLES-A														
;  50ms=04=SAMPLES-A														
;  60ms=05=SAMPLES-A														
;  70ms=06=SAMPLES-A														
;  80ms=07=SAMPLES-A														
;  90ms=08=nix																
; 100ms=09=nix																
; 110ms=10=nix																
; 120ms=11=nix																
; 130ms=12=SAMPLES-B														
; 140ms=13=SAMPLES-B														
; 150ms=14=SAMPLES-B														
; 160ms=15=SAMPLES-B														
; 170ms=16=SAMPLES-B														
; 180ms=17=SAMPLES-B														
; 190ms=18=nix																
; 200ms=19=nix																
;																			
;ca900ms=write																
DCF_SAMPLES_A_B_TEMP1:
	; ZEIGER laden		
	LDS temp,(adr_DCF_SAMPLES_ZEIGER)
	cpi temp,0							; 0			
	breq DCF_SAMPLES_A_B_DUMMY
	; Initialisierung	
	cpi temp,1							; 1			
	breq DCF_SAMPLES_A_B_INITIALISIERUNG
	; SAMPLES "A"		
	cpi temp,7+1						; 2...7		
	brlo DCF_SAMPLES_A
	cpi temp,11+1						; 8...11	
	brlo DCF_SAMPLES_A_B_DUMMY
	; SAMPLES "B"		
	cpi temp,17+1						; 12...17	
	brlo DCF_SAMPLES_B
	; LED				
	cpi temp,20
	breq DCF_MINUTEN_LED
	; WRITE				
	cpi temp,95							; 95 write		
	breq DCF_SAMPLES_WRITE
DCF_SAMPLES_A_B_DUMMY:
	ret
DCF_SAMPLES_A_B_INITIALISIERUNG:
	STS(adr_DCF_SAMPLES_A),NULL
	STS(adr_DCF_SAMPLES_B),NULL
	ret
;---------------------------------------------------------------------------
; SAMPLES "A"																
DCF_SAMPLES_A:
	tst temp1
	brne DCF_SAMPLES_Aw
	ret
DCF_SAMPLES_Aw:
	STS(adr_DCF_SAMPLES_A),EINS
	ret
;---------------------------------------------------------------------------
; SAMPLES "B"																
DCF_SAMPLES_B:
	tst temp1
	brne DCF_SAMPLES_Bw
	ret
DCF_SAMPLES_Bw:
	STS(adr_DCF_SAMPLES_B),EINS
	ret
;---------------------------------------------------------------------------
; kurzes aufleuchten der LED, wenn Minute erkannt							
DCF_MINUTEN_LED:
	LDS temp, (adr_DCF_ZEIGER)
	cpi temp,3
	brsh DCF_MINUTEN_LED_RUN
	ret
DCF_MINUTEN_LED_RUN:
	LDS temp,(adr_DCF_SAMPLES_A)
	tst temp
	breq DCF_MINUTEN_LED_w
	ret
DCF_MINUTEN_LED_w:
	LDS temp,(adr_DCF_SAMPLES_B)
	tst temp
	breq DCF_MINUTEN_LED_ww
	ret
DCF_MINUTEN_LED_ww:
	cbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
ret
;---------------------------------------------------------------------------
DCF_SAMPLES_WRITE:
	; MINUTENANFANG	A=B=0				
	LDS temp,(adr_DCF_SAMPLES_A)
	tst temp
	brne DCF_SAMPLES_WRITE_RUN
	LDS temp,(adr_DCF_SAMPLES_B)
	tst temp
	brne DCF_SAMPLES_WRITE_RUN
	; MINUTENANFANG erkannt			
	LDS temp,(adr_DCF_TURBOMODUS)
	tst temp
	brne DCF_TURBO
	rjmp DCF_MINUTENSTART_ZEIT_BERECHNUNG
DCF_SAMPLES_WRITE_RUN:
	;"B" BIT in's Datenfeld schreiben ("A"wird ignoriert)	
	LDS temp,(adr_DCF_SAMPLES_B)
	STS(adr_DCF_BIT),temp
	rjmp DCF_DATENFELD_SCHREIBEN
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_DATENFELD_SCHREIBEN:
	; Z-ZEIGER initialisieren	
	LDI ZL, low(adr_DCF_BEREICH)
	LDI ZH,high(adr_DCF_BEREICH)
	; DCF-ZEIGER laden			
	LDS temp, (adr_DCF_ZEIGER)
	; Fehlerprng				
	cpi temp,59
	brlo DCF_DATENFELD_SCHREIBEN_OK
;---------------------------------------------------------------------------
	; ERROR						
	ldi temp,(ERROR_DCF_DATENFELD)
	STS(adr_DCF_ERROR_CODE),temp
	; DCF GUELTIG auf NULL setzen	
	STS(adr_DCF_GUELTIG),NULL	
	; DCF-ZEIGER NULL				
	STS(adr_DCF_ZEIGER),NULL
	; LED							
	sbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR); DCF-GRUEN	
	ret
;---------------------------------------------------------------------------
DCF_DATENFELD_SCHREIBEN_OK:
	; addieren					
	add ZL,temp
	adc ZH,NULL
	; DCF ZEIGER +1				
	inc temp
	STS (adr_DCF_ZEIGER),temp
	; DCF-BIT in's Datenfeld schreiben	
	LDS temp,(adr_DCF_BIT)
	ST Z,temp
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_TURBO:
	STS(adr_DCF_TURBOMODUS),NULL

; das Datenfeld zurechtschieben			

	; Zeiger laden		
	LDS temp, (adr_DCF_ZEIGER)
	; Differenz bilden	
	ldi temp1,59
	sub temp1,temp

DCF_TURBO_w:
	rcall DATENFELD_SCHIEBEN
	dec temp1
	brne DCF_TURBO_w

;---------------------------------------------------------------------------
	LDS temp, (adr_DCF_ZEIGER)
	cpi temp,42
	brsh DCF_TURBO_KOMPLETT
	cpi temp,38
	brsh DCF_TURBO_MINUTE
	cpi temp,30
	brsh DCF_TURBO_STUNDE
	rjmp DCF_TURBO_DATUM
;---------------------------------------------------------------------------
DCF_TURBO_KOMPLETT:
	ldi temp,59
	STS(adr_DCF_ZEIGER),temp
	STS(adr_DCF_BEREICH+0),NULL
	rjmp DCF_MINUTENSTART_ZEIT_BERECHNUNG
DCF_TURBO_MINUTE:
	rcall DCF_ZEIT_21
	rjmp DCF_TURBO_FERTIG
DCF_TURBO_STUNDE:
	rcall DCF_ZEIT_29	
	rjmp DCF_TURBO_FERTIG
DCF_TURBO_DATUM:
	rcall DCF_ZEIT_36
	rjmp DCF_TURBO_FERTIG
;---------------------------------------------------------------------------
DCF_TURBO_FERTIG:
	STS(adr_DCF_GUELTIG),NULL
	STS(adr_DCF_ZEIGER),NULL
	sbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;	LDS temp,(adr_DCF_BEREICH+58)
DATENFELD_SCHIEBEN:
	push temp
	push temp1
	push ZL
	push ZH

	ldi temp1,59

	ldi ZL,LOW (adr_DCF_BEREICH+58-1)
	ldi ZH,HIGH(adr_DCF_BEREICH+58-1)

DATENFELD_SCHIEBEN_w:
	LD temp,Z	; laden		
	adiw ZL,1	; +1		
	ST Z,temp	; speichern	
	sbiw ZL,2	; -2		
	dec temp1
	brne DATENFELD_SCHIEBEN_w

	pop ZH
	pop ZL
	pop temp1
	pop temp
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;Bit(s) Anzahl 		Bedeutung 												
; 0 	1 bit	Start einer neuen Minute (ist immer "0") 					
;16 				"1": Am Ende dieser Stunde wird MEZ/MESZ umgestellt. 	
;17 				"0": MEZ, "1": MESZ 									
;18 				"0": MESZ, "1": MEZ 									
;19 				"1": Am Ende dieser Stunde wird eine Schaltsekunde eingefgt. 
;20 		1 bit 	Beginn der Zeitinformation (ist immer "1") 				
;21-27 		7 bit 	Minute (Werte der einzelnen Bits: 1,2,4,8,10,20,40) 	
;28 		1 bit 	Paritt Minute 											
;29-34 		6 bit 	Stunde (1, 2, 4, 8, 10, 20) 							
;35 		1 bit 	Paritt Stunde 											
;36-41 		6 bit 	Monatstag (1, 2, 4, 8, 10, 20) 							
;42-44 		3 bit 	Wochentag (1, 2, 4) 									
;45-49 		5 bit 	Monat (1, 2, 4, 8, 10) 									
;50-57 		8 bit 	Jahr (zweistellig; 1, 2, 4, 8, 10, 20, 40, 80) 			
;58 		1 bit 	Paritt Datum 											
DCF_MINUTENSTART_ZEIT_BERECHNUNG:
	; DCF GUELTIG auf NULL setzen		
	STS(adr_DCF_GUELTIG),NULL
	sbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR); DCF-GRUEN	
	; DCF-Zeiger muss auf 59 stehen		
	LDS temp, (adr_DCF_ZEIGER)
	STS(adr_DCF_ZEIGER),NULL	; DCF-ZEIGER NULL	
	cpi temp,59
	breq DCF_ZEIT_00
	; ERROR								
	ldi temp,(ERROR_DCF_MINUTENIMPULS)
	STS(adr_DCF_ERROR_CODE),temp
	ret
;---------------------------------------------------------------------------
;0 	Start einer neuen Minute (ist immer "0") 				
DCF_ZEIT_00:
	LDS temp,(adr_DCF_BEREICH+0)			; aus SRAM laden	
 	tst temp 
	breq DCF_ZEIT_00_OK
	; ERROR						
	ldi temp,(ERROR_DCF_NO_ANFANGSBIT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_00_OK:
;---------------------------------------------------------------------------
;1-14 Wetterdaten															
DCF_ZEIT_01:
;---------------------------------------------------------------------------
;15 Reserveantenne aktiv													
DCF_ZEIT_15:
;---------------------------------------------------------------------------
;16 Umstellung von MEZ auf MESZ oder umgekehrt								
DCF_ZEIT_16:
;---------------------------------------------------------------------------
;17 SOMMERZEIT aktiv				"0": MEZ, "1": MESZ 					
DCF_ZEIT_17:
	LDS temp,(adr_DCF_BEREICH+17)			; aus SRAM laden	
	STS (adr_DCF_MESZ),temp			; im SRAM ablegen	
;18 NORMALZEIT aktiv				"1": MEZ, "0": MESZ 					
DCF_ZEIT_18:
	LDS temp1,(adr_DCF_BEREICH+18)			; aus SRAM laden	
	; MEZ<>MESZ					
	add temp,temp1
	cpi temp,1
	breq DCF_ZEIT_18_OK
	; ERROR						
	ldi temp,(ERROR_DCF_MESZ)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_18_OK:
;19 Ankndigung Schaltsekunde												
DCF_ZEIT_19:
;---------------------------------------------------------------------------
;20 Beginn der Zeitinformation (ist immer "1") 								
DCF_ZEIT_20:
	LDS temp,(adr_DCF_BEREICH+20)			; aus SRAM laden	
 	tst temp 
	brne DCF_ZEIT_20_OK
	; ERROR-CODE			
	ldi temp,(ERROR_DCF_NO_ZEITINFORMATIONSBIT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_20_OK:
;---------------------------------------------------------------------------
;21-27 	Minute (Werte der einzelnen Bits: 1,2,4,8,10,20,40) 				
DCF_ZEIT_21:
	clr temp1
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+21)
	ldi ZH,HIGH(adr_DCF_BEREICH+21)
	rcall FUNCTION_DCF_BIT_01	; 21
	rcall FUNCTION_DCF_BIT_02	; 22
	rcall FUNCTION_DCF_BIT_04	; 23
	rcall FUNCTION_DCF_BIT_08	; 24
	rcall FUNCTION_DCF_BIT_10	; 25
	rcall FUNCTION_DCF_BIT_20	; 26
	rcall FUNCTION_DCF_BIT_40	; 27
	; MINUTENWERT bernehmen	
	STS(adr_DCF_mm),temp1
	; Fehlerprfung MINUTE 0...59
	cpi temp1,(59+1)
	brlo DCF_ZEIT_27_OK
	; ERROR						
	ldi temp,(ERROR_DCF_MINUTE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_27_OK:
;28  	Paritt Minute 											
DCF_ZEIT_28:
	; Paritt berechnen			
	clr temp1
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+21)
	ldi ZH,HIGH(adr_DCF_BEREICH+21)
	rcall FUNCTION_PARITAET	; 21
	rcall FUNCTION_PARITAET	; 22
	rcall FUNCTION_PARITAET	; 23
	rcall FUNCTION_PARITAET	; 24
	rcall FUNCTION_PARITAET	; 25
	rcall FUNCTION_PARITAET	; 26
	rcall FUNCTION_PARITAET	; 27
	; Paritt laden				
	LDS temp,(adr_DCF_BEREICH+28) 			; aus SRAM laden	
	; Paritt vergleichen		
	cp temp1,temp
	breq DCF_ZEIT_28_OK
	; ERROR						
	ldi temp,(ERROR_DCF_PARITAET_MINUTE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_28_OK:
;---------------------------------------------------------------------------
;29-34 	 	Stunde (1, 2, 4, 8, 10, 20) 									
DCF_ZEIT_29:
	clr temp1
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+29)
	ldi ZH,HIGH(adr_DCF_BEREICH+29)
	rcall FUNCTION_DCF_BIT_01	; 29
	rcall FUNCTION_DCF_BIT_02	; 30
	rcall FUNCTION_DCF_BIT_04	; 31
	rcall FUNCTION_DCF_BIT_08	; 32
	rcall FUNCTION_DCF_BIT_10	; 33
	rcall FUNCTION_DCF_BIT_20	; 34
	; STUNDENWERT bernehmen		
	STS(adr_DCF_hh),temp1
	; Fehlerprfung STUNDE 0...23	
	cpi temp1,(23+1)
	brlo DCF_ZEIT_34_OK
	; ERROR							
	ldi temp,(ERROR_DCF_STUNDE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_34_OK:
;35 			Paritt Stunde 											
DCF_ZEIT_35:
	; Paritt berechnen		
	clr temp1
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+29)
	ldi ZH,HIGH(adr_DCF_BEREICH+29)
	rcall FUNCTION_PARITAET	; 29
	rcall FUNCTION_PARITAET	; 30
	rcall FUNCTION_PARITAET	; 31
	rcall FUNCTION_PARITAET	; 32
	rcall FUNCTION_PARITAET	; 33
	rcall FUNCTION_PARITAET	; 34
	; Paritt laden				
	LDS temp,(adr_DCF_BEREICH+35) 			; aus SRAM laden	
	; Paritt vergleichen		
	cp temp1,temp
	breq DCF_ZEIT_35_OK
	; ERROR-CODE				
	ldi temp,(ERROR_DCF_PARITAET_STUNDE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_35_OK:
;---------------------------------------------------------------------------
;36-41 		 	Monatstag (1, 2, 4, 8, 10, 20) 								
DCF_ZEIT_36:
	clr temp1
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+36)
	ldi ZH,HIGH(adr_DCF_BEREICH+36)
	rcall FUNCTION_DCF_BIT_01	; 36
	rcall FUNCTION_DCF_BIT_02	; 37
	rcall FUNCTION_DCF_BIT_04	; 38
	rcall FUNCTION_DCF_BIT_08	; 39
	rcall FUNCTION_DCF_BIT_10	; 40
	rcall FUNCTION_DCF_BIT_20	; 41
	; TAG bernehmen			
	STS(adr_DCF_TAG),temp1
	; Fehlerprfung TAG	1...31	
	tst temp1
	breq DCF_ZEIT_41_ERROR
	cpi temp1,(31+1)
	brlo DCF_ZEIT_41_OK
	; ERROR						
DCF_ZEIT_41_ERROR:
	ldi temp,(ERROR_DCF_TAG)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_41_OK:
;---------------------------------------------------------------------------
;42-44 		 	Wochentag (1, 2, 4) 										
DCF_ZEIT_42:
	clr temp1
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+42)
	ldi ZH,HIGH(adr_DCF_BEREICH+42)
	rcall FUNCTION_DCF_BIT_01	; 42
	rcall FUNCTION_DCF_BIT_02	; 43
	rcall FUNCTION_DCF_BIT_04	; 44
	; WOCHENTAG bernehmen		
	STS(adr_DCF_WOCHENTAG),temp1
	; Fehlerprfung WOCHENTAG 1=MO 1...7	
	tst temp1
	breq DCF_ZEIT_44_ERROR
	cpi temp1,(7+1)
	brlo DCF_ZEIT_44_OK
	; ERROR						
DCF_ZEIT_44_ERROR:
	ldi temp,(ERROR_DCF_WOCHENTAG)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_44_OK:
;---------------------------------------------------------------------------
;45-49 		 	Monat (1, 2, 4, 8, 10) 										
DCF_ZEIT_45:
	clr temp1
	; Z-ZEIGER						
	ldi ZL,LOW (adr_DCF_BEREICH+45)
	ldi ZH,HIGH(adr_DCF_BEREICH+45)
	rcall FUNCTION_DCF_BIT_01	; 45
	rcall FUNCTION_DCF_BIT_02	; 46
	rcall FUNCTION_DCF_BIT_04	; 47
	rcall FUNCTION_DCF_BIT_08	; 48
	rcall FUNCTION_DCF_BIT_10	; 49
	; MONAT bernehmen				
	STS(adr_DCF_MONAT),temp1
	; Fehlerprfung MONAT 1...12	
	tst temp1
	breq DCF_ZEIT_49_ERROR
	cpi temp1,(12+1)
	brlo DCF_ZEIT_49_OK
	; ERROR							
DCF_ZEIT_49_ERROR:
	ldi temp,(ERROR_DCF_MONAT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_49_OK:
;---------------------------------------------------------------------------
;50-57 		 	Jahr (zweistellig; 1, 2, 4, 8, 10, 20, 40, 80) 				
DCF_ZEIT_50:
	clr temp1
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+50)
	ldi ZH,HIGH(adr_DCF_BEREICH+50)
	rcall FUNCTION_DCF_BIT_01	; 50
	rcall FUNCTION_DCF_BIT_02	; 51
	rcall FUNCTION_DCF_BIT_04	; 52
	rcall FUNCTION_DCF_BIT_08	; 53
	rcall FUNCTION_DCF_BIT_10	; 54
	rcall FUNCTION_DCF_BIT_20	; 55
	rcall FUNCTION_DCF_BIT_40	; 56
	rcall FUNCTION_DCF_BIT_80	; 57
	; JAHR bernehmen			
	STS(adr_DCF_JAHR),temp1
	; Fehlerprfung Jahr 12...40
	cpi temp1,(40+1)		; <=40
	brlo DCF_ZEIT_57_OK
	cpi temp1,(12)		; >=12
	brsh DCF_ZEIT_57_OK
	; ERROR						
	ldi temp,(ERROR_DCF_JAHR)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_57_OK:
;58 Paritt Datum 											
DCF_ZEIT_58:
	; Paritt berechnen		
	clr temp1
	; Z-ZEIGER					
	ldi ZL,LOW (adr_DCF_BEREICH+36)
	ldi ZH,HIGH(adr_DCF_BEREICH+36)
	rcall FUNCTION_PARITAET	; 36	; TAG			
	rcall FUNCTION_PARITAET	; 37
	rcall FUNCTION_PARITAET	; 38
	rcall FUNCTION_PARITAET	; 39
	rcall FUNCTION_PARITAET	; 40
	rcall FUNCTION_PARITAET	; 41
	rcall FUNCTION_PARITAET	; 42	; WOCHENTAG		
	rcall FUNCTION_PARITAET	; 43
	rcall FUNCTION_PARITAET	; 44
	rcall FUNCTION_PARITAET	; 45	; MONAT			
	rcall FUNCTION_PARITAET	; 45
	rcall FUNCTION_PARITAET	; 47
	rcall FUNCTION_PARITAET	; 48
	rcall FUNCTION_PARITAET	; 49
	rcall FUNCTION_PARITAET	; 50	; JAHR			
	rcall FUNCTION_PARITAET	; 51
	rcall FUNCTION_PARITAET	; 52
	rcall FUNCTION_PARITAET	; 53
	rcall FUNCTION_PARITAET	; 54
	rcall FUNCTION_PARITAET	; 55
	rcall FUNCTION_PARITAET	; 56
	rcall FUNCTION_PARITAET	; 57
	; Paritt laden				
	LDS temp,(adr_DCF_BEREICH+58) 			; aus SRAM laden	
	; Paritt vergleichen		
	cp temp1,temp
	breq DCF_ZEIT_58_OK
	; ERROR						
	ldi temp,(ERROR_DCF_PARITAET_DATUM)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_58_OK:
; --------------------------------------------------------------------------
	; DCF-ZEIT ist korrekt !!!		 
	cbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
	; DCF_GUELTIG				
	STS(adr_DCF_GUELTIG),EINS
	; PROGRAMMFREIGABE	
	STS(adr_FREIGABE_PROGRAMM),EINS
	; NULL						
	STS(adr_DCF_ZEIGER),NULL	
	STS(adr_ss_VT),NULL
	STS(adr_ss_100),NULL
	STS(adr_ss),NULL
	; MINUTEN					
	LDS temp,(adr_DCF_mm) 				; aus SRAM laden	
	STS (adr_mm),temp					; in SRAM speichern	
	; STUNDEN					
	LDS temp,(adr_DCF_hh) 				; aus SRAM laden	
	STS (adr_hh),temp					; in SRAM speichern	
	; TAG						
	LDS temp,(adr_DCF_TAG) 				; aus SRAM laden	
	STS (adr_TAG),temp					; in SRAM speichern	
	; Wochentag					
	LDS temp,(adr_DCF_WOCHENTAG) 		; aus SRAM laden	
	STS (adr_WOCHENTAG),temp			; in SRAM speichern	
	; MONAT						
	LDS temp,(adr_DCF_MONAT) 			; aus SRAM laden	
	STS (adr_MONAT),temp				; in SRAM speichern	
	; JAHR						
	LDS temp,(adr_DCF_JAHR) 			; aus SRAM laden	
	STS (adr_JAHR),temp					; in SRAM speichern	
	; MESZ						
	LDS temp,(adr_DCF_MESZ) 			; aus SRAM laden	
	STS (adr_MESZ),temp					; in SRAM speichern	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; INP: Z																	
; OUT: temp1 (PARITT)														
; OUT: Z																	
FUNCTION_PARITAET:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	add temp1,temp
	; BIT-MUSTER (bei gerader Anzahl von HIGH = NULL)
	andi temp1,0b00000001
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; 1, 2, 4, 8, 10, 20, 40, 80												
; INP: Z																	
; OUT: temp1																
; OUT: Z																	
FUNCTION_DCF_BIT_01:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-1 ; +1	
	ret
FUNCTION_DCF_BIT_02:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-2 ;+2	
	ret
FUNCTION_DCF_BIT_04:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-4 ;+ 4
	ret
FUNCTION_DCF_BIT_08:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-8 ;+ 8
	ret
FUNCTION_DCF_BIT_10:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-10 ;+ 10
	ret
FUNCTION_DCF_BIT_20:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-20 ;+ 20
	ret
FUNCTION_DCF_BIT_40:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-40 ;+ 40
	ret
FUNCTION_DCF_BIT_80:
	LD temp,Z	; laden Z	
	adiw ZL,1	; Z+1		
	tst temp
	breq FUNCTION_DCF_BIT_FERTIG
	subi temp1,-80 ;+ 80
	ret
FUNCTION_DCF_BIT_FERTIG:
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
