; ##############################################################################
; ##############################################################################
; ##############################################################################
Watchdog_aktivieren:
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	; TASTE gedrckt ?	
	LDS temp,(adr_TASTE)
	cpi temp,1
	breq MENUE_PLUS
	cpi temp,2
	breq MENUE_MINUS
	cpi temp,3
	breq MENUE_RESET
	rjmp MENUE_RUN
MENUE_PLUS:
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
	rjmp MENUE_RUN	
MENUE_MINUS:
	LDS temp,(adr_MENUE)
	dec temp
	; berlauf			
	cpi temp,255
	breq MENUE_RUN	
	STS(adr_MENUE),temp
	rjmp MENUE_RUN
;-------------------------------------------------------------------------------
MENUE_RESET:
	; alle LEDS an		
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)			; GRN 		
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)			; GELB 		
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)				; ROT  		
	cbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	cbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	; DCF-GELB	
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)		; DCF-ROT	
	rjmp MENUE_RESET
;-------------------------------------------------------------------------------
MENUE_RUN:
	; Z initialisieren	
	LDS temp,(adr_MENUE)
	ldi ZL,LOW (MENUE_SPRUNGMARKE)
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	add ZL,temp 
	adc ZH,NULL
	; SPRUNG nach Z		
	ijmp
MENUE_SPRUNGMARKE:
	rjmp ANZEIGE_DCF_UHR
	rjmp ANZEIGE_SONNE
	rjmp ANZEIGE_DCF_ONLINE_OFFLINE
	rjmp ANZEIGE_WARTUNG
	rjmp ANZEIGE_WARTUNG_SRAM
	rjmp ANZEIGE_KONFIGURATION
	rjmp ANZEIGE_BETRIEBSSTUNDEN
	rcall ANZEIGE_BEGRUESSUNG
	; berlauf
	STS(adr_MENUE),NULL
	STS(adr_TASTE),NULL
	rjmp MENUE
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	; SRAM		
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER	
	ret
; SCHLEIFE, bis WDR zubeit		
PROGRAMM_CHECK_FEHLER:
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 ; ROTDCF	
	rcall wait_100ms
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 ; ROTDCF	
	rcall wait_100ms
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; auf AUSGANG	
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)			; GRN		
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)			; GELB		
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)				; ROT		
	sbi (LED_DCF_GRUEN_DDR),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	sbi (LED_DCF_GELB_DDR),(LED_DCF_GELB_PIN_NR)  	; DCF-GELB	
	sbi (LED_DCF_ROT_DDR),(LED_DCF_ROT_PIN_NR)		; DCF-ROT	
	; LEDs an		
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)			; GRN 		
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)			; GELB 		
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)				; ROT  		
	cbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	cbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	; DCF-GELB	
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)		; DCF-ROT	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	; AUS			
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)			; GRN 		
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)			; GELB 		
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)				; ROT  		
	sbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	sbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	; DCF-GELB	
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
	; AN			
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)			; GRN 		
	rcall wait_100ms
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)			; GELB 		
	rcall wait_100ms
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)				; ROT  		
	rcall wait_100ms
	cbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	rcall wait_100ms
	cbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	; DCF-GELB	
	rcall wait_100ms
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
	rcall wait_100ms
	; AUS			
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)			; GRN 		
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)			; GELB 		
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)				; ROT  		
	sbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	sbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	; DCF-GELB	
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTATUR_INITIALISIERUNG:	
	; auf EINGANG		
	cbi (TASTE_MENUE_PLUS_DDR), (TASTE_MENUE_PLUS_PIN_NR)
	cbi (TASTE_MENUE_MINUS_DDR), (TASTE_MENUE_MINUS_PIN_NR)
	cbi (TASTE_PLUS_DDR),(TASTE_PLUS_PIN_NR)
	cbi (TASTE_MINUS_DDR),(TASTE_MINUS_PIN_NR)
	; PULL-UP ein		
	sbi (TASTE_MENUE_PLUS_PORT),(TASTE_MENUE_PLUS_PIN_NR)
	sbi (TASTE_MENUE_MINUS_PORT),(TASTE_MENUE_MINUS_PIN_NR)
	sbi (TASTE_PLUS_PORT),(TASTE_PLUS_PIN_NR)
	sbi (TASTE_MINUS_PORT),(TASTE_MINUS_PIN_NR)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ABFRAGE_TASTATUR:
	clr temp
	; Entprellung(ZEIT)				
	ldi temp1,255
ABFRAGE_TASTATUR_s:
	WDR
	; PROGRAMM FREIGEBEN			
	LDS temp2,(adr_FREIGABE_PROGRAMM)
	tst temp2
	breq ABFRAGE_TASTATUR_s1
	; speichern						
	STS(adr_TASTE),temp
	ret
ABFRAGE_TASTATUR_s1:
	; Taste "MENUE-PLUS"gedrckt ?	
	sbis (TASTE_MENUE_PLUS_PIN),(TASTE_MENUE_PLUS_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,1
	; Taste "MENUE-MINUS"gedrckt ?	
	sbis (TASTE_MENUE_MINUS_PIN),(TASTE_MENUE_MINUS_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,2
	; Taste "PLUS"gedrckt ?		
	sbis (TASTE_PLUS_PIN),(TASTE_PLUS_PIN_NR)				; springe, wenn BIT(PIN) high	
	SBR temp,4
	; Taste "MINUS"gedrckt ?		
	sbis (TASTE_MINUS_PIN),(TASTE_MINUS_PIN_NR)				; springe, wenn BIT(PIN) high	
	SBR temp,8
	; Warteschleife / Entprellung	
	rcall wait_1ms
	dec temp1
	brne ABFRAGE_TASTATUR_s
	; speichern						
	STS(adr_TASTE),temp
	tst temp
	brne ABFRAGE_TASTATUR_w
	ret
ABFRAGE_TASTATUR_w:
	; PROGRAMM FREIGEBEN			
	STS(adr_FREIGABE_PROGRAMM),EINS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTATUR_WAIT:
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTATUR_WAIT_RUN
	ret
TASTATUR_WAIT_RUN:
	STS(adr_TASTE),NULL
	rcall wait_100ms
	rcall wait_100ms
	rcall wait_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_DCF_ONLINE_OFFLINE:
	; initialisieren	
	LDS temp1,(adr_mm)
	LDS temp2,(adr_hh)
	LDS temp3,(adr_TAG)
	LDS temp4,(adr_MONAT)
	LDS temp5,(adr_JAHR)
	; DCF gltig ?		
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	breq BERECHNUNG_DCF_ONLINE_OFFLINE_OFF
	rjmp BERECHNUNG_DCF_ONLINE_OFFLINE_ON
BERECHNUNG_DCF_ONLINE_OFFLINE_OFF:
	STS(adr_DCF_OFFLINE_mm),temp1
	STS(adr_DCF_OFFLINE_hh),temp2
	STS(adr_DCF_OFFLINE_TAG),temp3
	STS(adr_DCF_OFFLINE_MONAT),temp4
	STS(adr_DCF_OFFLINE_JAHR),temp5
	ret
BERECHNUNG_DCF_ONLINE_OFFLINE_ON:
	STS(adr_DCF_ONLINE_mm),temp1
	STS(adr_DCF_ONLINE_hh),temp2
	STS(adr_DCF_ONLINE_TAG),temp3
	STS(adr_DCF_ONLINE_MONAT),temp4
	STS(adr_DCF_ONLINE_JAHR),temp5
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung ab 01.01.2000 mit Schaltjahr										
; INP: SRAM (adr_TAG)(adr_MONAT)(adr_JAHR)										
; OUT: SRAM (adr_KALENDERTAG_L) (adr_KALENDERTAG_H)								
FUNKTION_BERECHNUNG_KALENDERTAG:
	; Initialisierung 01.Januar			
	ldi temp1,1	; TAG					
	ldi temp2,1	; MONAT					
	ldi ZL,1	; KALENDERTAG_L			
	ldi ZH,0	; KALENDERTAG_H			
FUNKTION_BERECHNUNG_KALENDERTAG_VERGLEICH:
	WDR
	; Vergleich TAG		
	LDS temp,(adr_TAG)
	cp  temp,temp1
	brne FUNKTION_BERECHNUNG_KALENDERTAG_ZAEHLER
	; Vergleich MONAT	
	LDS temp,(adr_MONAT)
	cp  temp,temp2
	brne FUNKTION_BERECHNUNG_KALENDERTAG_ZAEHLER
	; speichern			
	STS(adr_KALENDERTAG_L),ZL
	STS(adr_KALENDERTAG_H),ZH
	ret
;-------------------------------------------------------------------------------
FUNKTION_BERECHNUNG_KALENDERTAG_ZAEHLER:
	; KALENDERTAG+1		
	adiw ZL,1
	; TAG + 1			
	inc temp1
	rcall FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_TEMP
	; TAG <> TAGE im MONAT
	cp temp1,temp
	brlo FUNKTION_BERECHNUNG_KALENDERTAG_VERGLEICH	
	breq FUNKTION_BERECHNUNG_KALENDERTAG_VERGLEICH
	; TAG= 1			
	ldi temp1,1
	; MONAT + 1			
	inc temp2
	rjmp FUNKTION_BERECHNUNG_KALENDERTAG_VERGLEICH
;-------------------------------------------------------------------------------
FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_TEMP:
	cpi temp2,2			; Februar 28/29	
	breq FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_28_29
	cpi temp2,4			; April 30		
	breq FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_30
	cpi temp2,6			; Juni 30		
	breq FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_30
	cpi temp2,8			; September 30	
	breq FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_30
	cpi temp2,11		; November 30	
	breq FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_30
	; MONATE mit 31 TAGEN	
	ldi temp,31
	ret
;-------------------------------------------------------------------------------
FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_28_29:
	; JAHR laden					
	LDS temp,(adr_JAHR)
FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_28_29w:
	tst temp
	; wenn NULL, dann Schaltjahr	
	breq FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_29
	; wenn negativ, kein Schaltjahr	
	brmi FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_28
	; JAHR-4						
	subi temp,4
	rjmp FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_28_29w

;-------------------------------------------------------------------------------
FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_28:
	ldi temp,28
	ret
FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_29:
	ldi temp,29
	ret
FUNKTION_BERECHNUNG_KALENDERTAG_TAGE_IM_MONAT_30:
	ldi temp,30
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: SRAM																		
FUNKTION_SONNENAUFGANG_UNTERGANG_BERECHNEN:
	; Z auf Tabelle			
	LDI ZL,low (TABELLE_SONNENAUFGANG*2)
	LDI ZH,high(TABELLE_SONNENAUFGANG*2)
	; WERT aus TABELLE		
	rcall FUNKTION_TABELLENWERT_UMWANDELN_TEMP1_TEMP2	; INP/OUT: temp1+2
	STS(adr_SONNE_AUFGANG_mm),temp1
	STS(adr_SONNE_AUFGANG_hh),temp2
;-------------------------------------------------------------------------------
	; Z auf Tabelle			
	LDI ZL,low (TABELLE_SONNENUNTERGANG*2)
	LDI ZH,high(TABELLE_SONNENUNTERGANG*2)
	; WERT aus TABELLE		
	rcall FUNKTION_TABELLENWERT_UMWANDELN_TEMP1_TEMP2	; INP/OUT: temp1+2
	STS(adr_SONNE_UNTERGANG_mm),temp1
	STS(adr_SONNE_UNTERGANG_hh),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: Z (TABELLE)																
; OUT: temp1+2																	
FUNKTION_TABELLENWERT_UMWANDELN_TEMP1_TEMP2:
	; Kalendertag laden			
	LDS temp1,(adr_KALENDERTAG_L)
	LDS temp2,(adr_KALENDERTAG_H)
	; Kalendertag -1			
	sub temp1,EINS
	sbc temp2,NULL
	; Kalendertag x 2			
	add ZL,temp1
	adc ZH,temp2
	add ZL,temp1
	adc ZH,temp2
	; WERT aus Tabelle laden		
	LPM temp1, Z+  	; LOW -BYTE
	LPM temp2, Z  	; HIGH-BYTE
;-------------------------------------------------------------------------------
	; BSP: temp1+2=819 ==> temp2=8 temp1=19	
	ldi temp5,255
FUNKTION_TABELLENWERT_UMWANDELN_s:
	; 100 subtrahieren			
	subi temp1, LOW (100)
	sbci temp2, HIGH(100)
	; Anzahl Schleifen Zhlen	
	inc temp5
	; ist noch positiv ?		
	tst temp2
	brpl FUNKTION_TABELLENWERT_UMWANDELN_s
	; 100 addieren				
	subi temp1, LOW (-100)
	sbci temp2, HIGH(-100)
	; Schleifenwert				
	mov temp2,temp5
;-------------------------------------------------------------------------------
	; SOMMERZEIT	
	LDS temp,(adr_MESZ)
	tst temp
	brne FUNKTION_TABELLENWERT_UMWANDELN_MESZ
	ret
FUNKTION_TABELLENWERT_UMWANDELN_MESZ:
	; STUNDE +1		
	inc temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
