; DCF77-MODUL (Samlingverfahren)				
; Bernhard.Erfurt@gmx.de						
; 09/2012										
;												
; 16 MHz										
; LCD 2X16										

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> LCD-DATA								
; PB1 ==> LCD-DATA								
; PB2 ==> LCD-DATA								
; PB3 ==> LCD-DATA								
; PB4 ==> LCD-RS								
; PB5 ==> LCD_E									
; PB6 ==> Quarz	16MHz							
; PB7 ==> Quarz	16MHz							
;												
; PC0 ==> EINGANG-TASTE	"MENUE +"				
; PC1 ==> EINGANG-TASTE	"MENUE -"				
; PC2 ==> 										
; PC3 ==> LED GRN (RESERVE)					
; PC4 ==> LED GELB (RESERVE)					
; PC5 ==> LED ROT  (RESERVE)					
;												
; PD0 ==> DCF-EINGANG							
; PD1 ==> DCF invertieren 						
; PD2 ==> DCF PULL-UP aktivieren				
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED DCF-GRN (DCF gltig)				
; PD6 ==> LED DCF-GELB (DCF Eingangssignal)		
; PD7 ==> LED DCF-ROT  (Uhr heute noch nicht gestellt)	
;												


; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT								=16000000			; 16 MHz	

; TIMER-WERTE									
.equ TIMERWERT0 						=256-250			;(2 hoch 8  minus 250)		bei 16MHz + Vorteiler   64 => 0.001s =1ms	
;.equ TIMERWERT0 						=256-125			;(2 hoch 8  minus 125)		bei  8MHz + Vorteiler   64 => 0.001s =1ms	

; DCF-PHASE_TIMERWERT							
.equ DCF_PHASE_TIMERWERT				= 6					; (1...10) nach 3 Sekunden Phase schieben
; DCF-PORT										
.equ DCF_PIN_NR							= 0
.equ DCF_DDR							= DDRD
.equ DCF_PORT							= PORTD
.equ DCF_PIN							= PIND
; DCF-SIGNAL-INVERTIEREN						
.equ DCF_INV_PIN_NR						= 1
.equ DCF_INV_DDR						= DDRD
.equ DCF_INV_PORT						= PORTD
.equ DCF_INV_PIN						= PIND
; DCF-PIN interner PULL UP						
.equ DCF_PUL_PIN_NR						= 2
.equ DCF_PUL_DDR						= DDRD
.equ DCF_PUL_PORT						= PORTD
.equ DCF_PUL_PIN						= PIND
; DCF-ERROR-CODES								
.equ ERROR_DCF_DATENFELD				= 2
.equ ERROR_DCF_MINUTENIMPULS			= 10
.equ ERROR_DCF_NO_ANFANGSBIT			= 12
.equ ERROR_DCF_NO_ZEITINFORMATIONSBIT	= 14
.equ ERROR_DCF_MESZ						= 16
.equ ERROR_DCF_PARITAET_MINUTE			= 100
.equ ERROR_DCF_PARITAET_STUNDE			= 110
.equ ERROR_DCF_PARITAET_DATUM			= 120
.equ ERROR_DCF_STUNDE					= 130
.equ ERROR_DCF_MINUTE					= 140
.equ ERROR_DCF_TAG						= 150
.equ ERROR_DCF_WOCHENTAG				= 160
.equ ERROR_DCF_MONAT					= 170
.equ ERROR_DCF_JAHR						= 180
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 3
.equ LED_GRUEN_DDR					= DDRC
.equ LED_GRUEN_PORT					= PORTC
; LED-GELB										
.equ LED_GELB_PIN_NR				= 4
.equ LED_GELB_DDR					= DDRC
.equ LED_GELB_PORT					= PORTC
; LED-ROT										
.equ LED_ROT_PIN_NR					= 5
.equ LED_ROT_DDR					= DDRC
.equ LED_ROT_PORT					= PORTC
; LED-DCF-GRUEN									
.equ LED_DCF_GRUEN_PIN_NR			= 5
.equ LED_DCF_GRUEN_DDR				= DDRD
.equ LED_DCF_GRUEN_PORT				= PORTD
; LED-DCF-GELB									
.equ LED_DCF_GELB_PIN_NR			= 6
.equ LED_DCF_GELB_DDR				= DDRD
.equ LED_DCF_GELB_PORT				= PORTD
; LED-DCF-ROT									
.equ LED_DCF_ROT_PIN_NR				= 7
.equ LED_DCF_ROT_DDR				= DDRD
.equ LED_DCF_ROT_PORT				= PORTD
; TASTE "MENUE-PLUS"							
.equ TASTE_MENUE_PLUS_PIN_NR		= 0
.equ TASTE_MENUE_PLUS_PIN			= PINC
.equ TASTE_MENUE_PLUS_DDR			= DDRC
.equ TASTE_MENUE_PLUS_PORT			= PORTC
; TASTE "MENUE-MINUS"							
.equ TASTE_MENUE_MINUS_PIN_NR		= 1
.equ TASTE_MENUE_MINUS_PIN			= PINC
.equ TASTE_MENUE_MINUS_DDR			= DDRC
.equ TASTE_MENUE_MINUS_PORT			= PORTC
; TASTE "PLUS"									
.equ TASTE_PLUS_PIN_NR				= 2	; DUMMY
.equ TASTE_PLUS_PIN					= PINC
.equ TASTE_PLUS_DDR					= DDRC
.equ TASTE_PLUS_PORT				= PORTC
; TASTE "MINUS"									
.equ TASTE_MINUS_PIN_NR				= 2	; DUMMY
.equ TASTE_MINUS_PIN				= PINC
.equ TASTE_MINUS_DDR				= DDRC
.equ TASTE_MINUS_PORT				= PORTC
; LCD (DATA)									
.equ LCD_DATA0_DDR					= DDRB
.equ LCD_DATA1_DDR					= DDRB
.equ LCD_DATA2_DDR					= DDRB
.equ LCD_DATA3_DDR					= DDRB
.equ LCD_DATA0_PORT					= PORTB
.equ LCD_DATA1_PORT					= PORTB
.equ LCD_DATA2_PORT					= PORTB
.equ LCD_DATA3_PORT					= PORTB
.equ LCD_DATA0						= 0
.equ LCD_DATA1						= 1
.equ LCD_DATA2						= 2
.equ LCD_DATA3						= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR						= DDRB
.equ LCD_RS_PORT					= PORTB
.equ LCD_RS							= 4
; LCD_ENABLE									
.equ LCD_E_DDR						= DDRB
.equ LCD_E_PORT						= PORTB
.equ LCD_E							= 5
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					=0x0060			; 0x0060 START Adresse 		

.equ adr_FREIGABE_PROGRAMM		=0x0060+0		
.equ adr_MENUE					=0x0060+1
.equ adr_TASTE					=0x0060+2

.equ adr_ss_VT					=0x0060+20			; Vorteiler	
.equ adr_ss_100					=0x0060+21			; 100-el	
.equ adr_ss						=0x0060+22			; Sekunden	
.equ adr_mm						=0x0060+23			; Minuten	
.equ adr_hh						=0x0060+24			; Stunden	
.equ adr_TAG					=0x0060+25			; Tag		
.equ adr_WOCHENTAG				=0x0060+26			; WochenTag	
.equ adr_MONAT					=0x0060+27			; Monat		
.equ adr_JAHR					=0x0060+28			; Jahr		
.equ adr_MESZ					=0x0060+29			; MESZ		


.equ adr_KALENDERTAG_L			=0x0060+50			; Kalendertage 01.01.=1	
.equ adr_KALENDERTAG_H			=0x0060+51


.equ adr_SONNE_AUFGANG_mm		=0x0060+60			; SONNENAUFGANG				
.equ adr_SONNE_AUFGANG_hh		=0x0060+61			; SONNENAUFGANG				
.equ adr_SONNE_UNTERGANG_mm		=0x0060+62			; SONNENUNTERGANG			
.equ adr_SONNE_UNTERGANG_hh		=0x0060+63			; SONNENUNTERGANG

.equ adr_BS_ss					=0x0060+80			; BETRIEBSSTUNDEN		
.equ adr_BS_mm					=0x0060+81
.equ adr_BS_hh					=0x0060+82
.equ adr_BS_TAG_L				=0x0060+83
.equ adr_BS_TAG_H				=0x0060+84

.equ adr_DCF_ONLINE_mm			=0x0060+90			; ONLINE	
.equ adr_DCF_ONLINE_hh			=0x0060+91
.equ adr_DCF_ONLINE_TAG			=0x0060+92
.equ adr_DCF_ONLINE_MONAT		=0x0060+93
.equ adr_DCF_ONLINE_JAHR		=0x0060+94
.equ adr_DCF_OFFLINE_mm			=0x0060+95			; OFFLINE	
.equ adr_DCF_OFFLINE_hh			=0x0060+96
.equ adr_DCF_OFFLINE_TAG		=0x0060+97
.equ adr_DCF_OFFLINE_MONAT		=0x0060+98
.equ adr_DCF_OFFLINE_JAHR		=0x0060+99

.equ adr_DCF_mm					=0x0060+100			; Minuten 	aus DCF-Protokoll	
.equ adr_DCF_hh					=0x0060+101			; Stunden 	aus DCF-Protokoll	
.equ adr_DCF_TAG				=0x0060+102			; Tag	 	aus DCF-Protokoll	
.equ adr_DCF_WOCHENTAG			=0x0060+103			; WochenTag aus DCF-Protokoll	
.equ adr_DCF_MONAT				=0x0060+104			; Monat	 	aus DCF-Protokoll	
.equ adr_DCF_JAHR				=0x0060+105			; Jahr	 	 aus DCF-Protokoll	
.equ adr_DCF_MESZ				=0x0060+106			; SOMMERZEIT aus DCF-Protokoll	

.equ adr_DCF_INVERTIERMODUS		=0x0060+110			; 1=EINGANSPEGEL invertieren	
.equ adr_DCF_PULL_UP			=0x0060+111			; 1=EINGANGS-PULL-UP ein		

.equ adr_DCF_SAMPLES_ZEIGER		=0x0060+120			; ZEIGER fr SAMPLES			
.equ adr_DCF_SAMPLES_A			=0x0060+121			; SAMPLES_A (100ms)				
.equ adr_DCF_SAMPLES_B			=0x0060+122			; SAMPLES_A (200ms)				
.equ adr_DCF_BIT				=0x0060+124			; DCF-BIT						

.equ adr_DCF_IMPULS_OLD			=0x0060+130
.equ adr_DCF_IMPULS_PHASE		=0x0060+131			; PHASE							
.equ adr_DCF_PHASE_TIMER		=0x0060+132			; TIMER fr PHASE				
.equ adr_DCF_TURBOMODUS			=0x0060+133			; TURBOMODUS bei PROGRAMMSTART 	

.equ adr_DCF_ZEIGER				=0x0060+150			; Zeiger fr DCF-FELD			
.equ adr_DCF_GUELTIG			=0x0060+151			; DCF-Protokoll ist geprft und gltig			
.equ adr_DCF_ERROR_CODE			=0x0060+152			; DCF-ERROR-CODE				

.equ adr_DCF_BEREICH			=0x0060+160	 		; 60 BYTES fr DCF-FELD			

.equ adr_SRAM_CHECK				=0x0060+900			; Programm-Check				


; REGISTER										

.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR  	; Timer1 Overflow Handler           					
rjmp TIM0_OVF			;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 					
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 ; ROTDCF	
	rcall wait_100ms
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 ; ROTDCF	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM CLEAR										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	
; PORT B initialisieren								
	ldi temp, 0b00000000	
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000
	out DDRD, temp			
; PORT D setzen										
	ldi temp, 0b00000000
	out PORTD, temp				
; LED_INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; Watchdog aktivieren (max. Zeit)					
	rcall Watchdog_aktivieren
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED_TEST											
	rcall LED_TEST
; TASTATUR_INITIALISIERUNG							
	rcall TASTATUR_INITIALISIERUNG
; DCF_INITIALISIERUNG								
	rcall DCF_INITIALISIERUNG
	rcall DCF_EINGANGSPEGEL_INVERTIEREN_ABFRAGEN
	rcall DCF_EINGANGS_PULL_UP_AKTIVIEREN
; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER aktivieren									
	rcall TIMER_AKTIVIEREN
; Startwerte										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; BETRIEBSSTUNDEN	
	ldi temp,0
	STS(adr_BS_ss),temp			; in SRAM speichern		
	ldi temp,59
	STS(adr_BS_mm),temp			; in SRAM speichern		
	ldi temp,23
	STS(adr_BS_hh),temp			; in SRAM speichern		
	ldi temp,255
	STS(adr_BS_TAG_L),temp		; in SRAM speichern		
	ldi temp,255
	STS(adr_BS_TAG_H),temp		; in SRAM speichern	
	; ZEIT				
	ldi temp,23
	STS(adr_hh),temp
	ldi temp,59
	STS(adr_mm),temp
	ldi temp,55
	STS(adr_ss),temp
	; DATUM				
	ldi temp,1
	STS(adr_TAG),temp
	ldi temp,1
	STS(adr_MONAT),temp
	ldi temp,1
	STS(adr_JAHR),temp
	; DCF-TURBOMODUS	
	STS(adr_DCF_TURBOMODUS),EINS
	; SRAM-CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
; LCD_INITIALISIERUNG								
	rcall LCD_INITIALISIERUNG
; ANZEIGE_BEGRUESSUNG								
	rcall ANZEIGE_BEGRUESSUNG
	rcall ANZEIGE_BEGRUESSUNG_2
	rcall ANZEIGE_KONFIGURATION
	rcall WAIT_1s
; interrupts freigeben								
	sei
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	rcall ABFRAGE_TASTATUR
	LDS temp,(adr_FREIGABE_PROGRAMM)
	tst temp 
	breq LOOP
;-------------------------------------------------------------------------------
	STS(adr_FREIGABE_PROGRAMM),NULL
	rcall FUNKTION_BERECHNUNG_KALENDERTAG
	rcall FUNKTION_SONNENAUFGANG_UNTERGANG_BERECHNEN
	rcall MENUE
	rcall BERECHNUNG_DCF_ONLINE_OFFLINE
	rcall PROGRAMM_CHECK
	rcall TASTATUR_WAIT
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "DCF77_TIMER.asm"
.include "DCF77_SONSTIGES.asm"
.include "DCF77_DCF.asm"
.include "DCF77_LCD_ini.asm"
.include "DCF77_LCD.asm"
.include "DCF77_LCD_KURZ.asm"
;.include "DCF77_08MHZwait.asm"
.include "DCF77_16MHZwait.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################
TABELLE_SONNENAUFGANG:
; TABELLE_SONNENAUFGANG											
; 01.01. = 819= "08:19 "UHR (GMT+1)								
;    1   2   3   4   5   6   7   8   9   10  11  12  13  14  15  16  17  18  19  20  21  22  23  24  25  26  27  28  29  30  31		
.dw 819,819,818,818,818,817,817,816,816,815,815,814,813,813,812,811,810,809,808,807,806,805,804,803,802,800,759,758,756,755,754 ; 01
.dw 752,751,749,748,746,744,743,741,739,738,736,734,732,730,729,727,725,723,721,719,717,715,713,711,709,707,705,703				; 02
.dw 700,658,656,654,652,650,647,645,643,641,638,636,634,632,629,627,625,623,620,618,616,613,611,609,606,604,602,600,557,555,553 ; 03
.dw 550,548,546,544,541,539,537,535,532,530,528,526,523,521,519,517,515,513,511,509,506,504,502,500,458,456,454,453,451,449		; 04
.dw 447,445,443,441,440,438,436,435,433,431,430,428,427,425,424,422,421,420,418,417,416,415,414,412,411,410,409,409,408,407,406 ; 05
.dw 405,405,404,403,403,402,402,401,401,401,401,400,400,400,400,400,400,400,400,401,401,401,401,402,402,403,403,404,404,405		; 06
.dw 406,407,407,408,409,410,411,412,413,414,415,416,417,419,420,421,422,424,425,426,428,429,430,432,433,435,436,438,439,441,442 ; 07
.dw 444,445,447,449,450,452,453,455,457,458,500,501,503,505,506,508,510,511,513,514,516,518,519,521,523,524,526,528,529,531,532 ; 08
.dw 534,536,537,539,541,542,544,546,547,549,550,552,554,555,557,559,600,602,603,605,607,608,610,612,613,615,616,618,620,621		; 09
.dw 623,625,626,628,630,631,633,635,636,638,640,641,643,645,646,648,650,651,653,655,656,658,700,701,703,705,706,708,710,712,713 ; 10
.dw 715,717,718,720,722,723,725,726,728,730,731,733,735,736,738,739,741,742,744,745,747,748,750,751,752,754,755,756,758,759		; 11
.dw 800,801,802,803,804,806,807,808,808,809,810,811,812,813,813,814,815,815,816,816,817,817,817,818,818,818,818,818,818,818,818 ; 12

TABELLE_SONNENUNTERGANG:
; TABELLE_SONNENUNTERGANG										
; 01.01. = 1621= "16:21 "UHR (GMT+1)							
;     1    2    3    4    5    6    7    8    9    10   11   12   13   14   15   16   17   18   19   20   21   22   23   24   25   26   27   28   29   30   31		
.dw 1621,1622,1623,1624,1625,1626,1628,1629,1630,1632,1633,1634,1636,1637,1639,1640,1642,1643,1645,1646,1648,1649,1651,1652,1654,1656,1657,1659,1701,1702,1704  ; 01
.dw 1706,1708,1709,1711,1713,1714,1716,1718,1720,1721,1723,1725,1727,1728,1730,1732,1734,1736,1737,1739,1741,1743,1744,1746,1748,1749,1751,1753					; 02
.dw 1755,1756,1758,1800,1802,1803,1805,1807,1808,1810,1812,1814,1815,1817,1819,1820,1822,1824,1825,1827,1829,1831,1832,1834,1836,1837,1839,1841,1842,1844,1846	; 03
.dw 1847,1849,1851,1852,1854,1856,1857,1859,1901,1902,1904,1906,1908,1909,1911,1913,1914,1916,1918,1919,1921,1923,1924,1926,1928,1929,1931,1933,1934,1936		; 04
.dw 1938,1939,1941,1943,1944,1946,1947,1949,1950,1952,1954,1955,1957,1958,2000,2001,2003,2004,2005,2007,2008,2009,2011,2012,2013,2015,2016,2017,2018,2019,2020  ; 05
.dw 2021,2022,2023,2024,2025,2026,2027,2028,2028,2029,2030,2030,2031,2031,2032,2032,2033,2033,2033,2033,2034,2034,2034,2034,2034,2034,2033,2033,2033,2033		; 06
.dw 2032,2032,2032,2031,2031,2030,2029,2029,2028,2027,2026,2025,2025,2024,2023,2022,2020,2019,2018,2017,2016,2014,2013,2012,2010,2009,2007,2006,2004,2003,2001	; 07
.dw 1959,1958,1956,1954,1952,1951,1949,1947,1945,1943,1941,1939,1937,1935,1933,1931,1929,1927,1925,1923,1921,1918,1916,1914,1912,1910,1907,1905,1903,1901,1858	; 08
.dw 1856,1854,1852,1849,1847,1845,1842,1840,1838,1835,1833,1831,1828,1826,1823,1821,1819,1816,1814,1812,1809,1807,1805,1802,1800,1758,1755,1753,1751,1748		; 09
.dw 1746,1744,1741,1739,1737,1735,1732,1730,1728,1726,1724,1721,1719,1717,1715,1713,1711,1709,1707,1705,1703,1701,1659,1657,1655,1653,1652,1650,1648,1646,1645	; 10
.dw 1643,1641,1640,1638,1636,1635,1633,1632,1631,1629,1628,1626,1625,1624,1623,1622,1621,1619,1618,1617,1617,1616,1615,1614,1613,1613,1612,1611,1611,1610		; 11
.dw 1610,1609,1609,1609,1608,1608,1608,1608,1608,1608,1608,1608,1608,1608,1609,1609,1609,1610,1610,1611,1611,1612,1612,1613,1614,1615,1615,1616,1617,1618,1619	; 12

; ##############################################################################
; ##############################################################################
; ##############################################################################
TEXT_BEGRUESSUNG_1:
.db "ATmega8",0
TEXT_BEGRUESSUNG_2:
.db "DCF77 21.09.2012 ",0
TEXT_KONFIGURATION:
.db "Konfiguration",0



